// manually rewritten from CoffeeScript output
// (see dev-coffee branch for original source)

// navigator.getUserMedia shim

var localStream;
var allowrecord = false;

navigator.getUserMedia =
  navigator.getUserMedia ||
  navigator.webkitGetUserMedia ||
  navigator.mozGetUserMedia ||
  navigator.msGetUserMedia;

// URL shim
window.URL = window.URL || window.webkitURL;

// audio context + .createScriptProcessor shim
var audioContext = new AudioContext;
if (audioContext.createScriptProcessor == null)
  audioContext.createScriptProcessor = audioContext.createJavaScriptNode;

// elements (jQuery objects)
var $testToneLevel = $('#test-tone-level'),
    $microphone = $('#microphone'),
    $microphoneLevel = $('#microphone-level'),
    $encodingProcess = $('input[name="encoding-process"]'),
    $bufferSize = $('#buffer-size'),
    $bitRate = $('#bit-rate'),
    $recording = $('#recording'),
    $timeDisplay = $('#time-display'),
    $record = $('.recordbtn'),
    $cancel = $('#cancel'),
    $dateTime = $('#date-time'),
    $recordingList = $('#recording-list');

var testToneLevel = audioContext.createGain(),
    microphone = undefined,     // obtained by user click
    microphoneLevel = audioContext.createGain(),
    mixer = audioContext.createGain(),
    input = audioContext.createGain(),
    processor = undefined;      // created on recording
microphoneLevel.gain.value = 0.8;
microphoneLevel.connect(mixer);
mixer.connect(input);
//mixer.connect(audioContext.destination);


$microphoneLevel.on('input', function() {
  var level = $microphoneLevel[0].valueAsNumber / 100;
  microphoneLevel.gain.value = level * level;
});


  if (microphone == null)
    navigator.getUserMedia({ audio: true },
      function(stream) {
        localStream = stream;
        microphone = audioContext.createMediaStreamSource(stream);
        microphone.connect(microphoneLevel);
        $microphone.attr('disabled', true);
        $microphoneLevel.removeClass('hidden');
        allowrecord = true;
      },
      function(error) {
        $microphone[0].checked = false;
        window.alert("Could not get audio input.");
      });

// encoding process selector
var encodingProcess = 'separate';       // separate | background | direct

$encodingProcess.click(function(event) {
  encodingProcess = $(event.target).attr('mode');
});

// processor buffer size
var BUFFER_SIZE = [256, 512, 1024, 2048, 4096, 8192, 16384];

var defaultBufSz = (function() {
  processor = audioContext.createScriptProcessor(undefined, 2, 2);
  return processor.bufferSize;
})();

var iDefBufSz = BUFFER_SIZE.indexOf(defaultBufSz);
   // initialize with browser default

function updateBufferSizeText() {

}
function stoprecaudio() {
    stopRecording(false);
    if(microphone != undefined && microphone.mediaStream != undefined)
    microphone.mediaStream.getAudioTracks()[0].stop();
    
    if(audioContext.state != "closed")
    audioContext.close();
    
    allowrecord = false;
}

updateBufferSizeText();         // initialize text

$bufferSize.on('input', function() { updateBufferSizeText(); });

// MP3 bit rate
var BIT_RATE = [96];

$bitRate.on('input', function() {
  $('#bit-rate-text').html("" + BIT_RATE[$bitRate[0].valueAsNumber] + "kbps");
});

var cblob;

        $('.chat[data-id="0"] .audioupload').on('hide.bs.popover', function () {
            stoprecaudio();
        })
		

// save/delete recording
function saveRecording(blob) {
    cblob = blob;
    
  var time = new Date(),
      url = URL.createObjectURL(blob),
      html = "<div recording='" + url + "'>" +
             "<div class='col-sm-12'><audio controls src='" + url + "' style='width:100%;'></audio> " +
             "<a class='btn btn-default sendrecbtn pull-right'  onclick='uploadaudiorec()'>" +
             "Lähetä</a><button class='btn btn-danger' recording='" +
                      url + "'>x</button></div>" +
             "</div>";
  $recordingList.html($(html));
}

$recordingList.on('click', 'button', function(event) {
  var url = $(event.target).attr('recording');
  $("div[recording='" + url + "']").remove();
  URL.revokeObjectURL(url);
});

function uploadaudiorec(soundBlob) {
    $(".sendrecbtn").attr("onclick","").addClass("btn-disabled").html("Lähetetään");
   var fd = new FormData();
    fd.append('fname', Math.floor((Math.random() * 1000000) + 1) + '.mp3');
    fd.append('data', cblob);
    $.ajax({
        type: 'POST',
        url: 'https://omegle.fi/inc/audioupload.php',
        data: fd,
        processData: false,
        contentType: false
    }).done(function(data) {
           console.log(data);
        
        if(data != "false") {
            
            				
            if(type == "group" || type == "chatroom")
            newmsg(data, roomid[0], 1,0,gid[suserid[0]],9);
            else
            newmsg(data, roomid[0], 1,0,0,9);
            
            socket.emit('message', { room: roomid[0], user: suserid[0], message: data, meta: { type: 9 } });
        }
        popmedia.hide();
        stoprecaudio();
        
    }); 
}

$recordingList.on('click', 'button', function(event) {
  var url = $(event.target).attr('recording');
  $("p[recording='" + url + "']").remove();
  URL.revokeObjectURL(url);
});

// recording process
var worker = new Worker('js/EncoderWorker.js'),
    encoder = undefined;        // used on encodingProcess == direct

worker.onmessage = function(event) { saveRecording(event.data.blob); };

function getBuffers(event) {
  var buffers = [];
  for (var ch = 0; ch < 2; ++ch)
    buffers[ch] = event.inputBuffer.getChannelData(ch);
  return buffers;
}

function startRecordingProcess() {
  var bufSz = processor.bufferSize,
      bitRate = 96;
  processor = audioContext.createScriptProcessor(bufSz, 2, 2);
  input.connect(processor);
  processor.connect(audioContext.destination);
  if (encodingProcess === 'direct') {
    encoder = new Mp3LameEncoder(audioContext.sampleRate, bitRate);
    processor.onaudioprocess = function(event) {
      encoder.encode(getBuffers(event));
    };
  } else {
    worker.postMessage({
      command: 'start',
      process: encodingProcess,
      sampleRate: audioContext.sampleRate,
      bitRate: bitRate
    });
    processor.onaudioprocess = function(event) {
      worker.postMessage({ command: 'record', buffers: getBuffers(event) });
    };
  }
}

function stopRecordingProcess(finish) {
  input.disconnect();
  processor.disconnect();
  if (encodingProcess === 'direct')
    if (finish)
      saveRecording(encoder.finish());
    else
      encoder.cancel();
  else
    worker.postMessage({ command: finish ? 'finish' : 'cancel' });
}

// recording buttons interface
var startTime = null    // null indicates recording is stopped

function minSecStr(n) { return (n < 10 ? "0" : "") + n; }

function updateDateTime() {
  $dateTime.html((new Date).toString());
  if (startTime != null) {
    var sec = Math.floor((Date.now() - startTime) / 1000);
    $timeDisplay.html(minSecStr(sec / 60 | 0) + ":" + minSecStr(sec % 60));
  }
}

window.setInterval(updateDateTime, 200);

function disableControlsOnRecord(disabled) {
  if (microphone == null)
    $microphone.attr('disabled', disabled);
  $encodingProcess.attr('disabled', disabled);
  $bufferSize.attr('disabled', disabled);
  $bitRate.attr('disabled', disabled);
}

function startRecording() {
    if(allowrecord) {
      startTime = Date.now();
      $recording.removeClass('hidden');
      $record.html('STOP');
      $cancel.removeClass('hidden');
      disableControlsOnRecord(true);
      startRecordingProcess();
    }
}

function stopRecording(finish) {
  startTime = null;
  $timeDisplay.html('00:00');
  $recording.addClass('hidden');
  $recordingList.html("Ladataan");
  $record.html('REC');
  $cancel.addClass('hidden');
  disableControlsOnRecord(false);
  stopRecordingProcess(finish);
}

$record.click(function() {
  if (startTime != null)
    stopRecording(true);
  else
    startRecording();
});

$cancel.click(function() { stopRecording(false); });